//funcion que tiene la responsabilidad de ordenar aleatoriamente un arreglo
function shuffle(a) {
    var array = a.slice(0);
    var currentIndex = array.length,
        temporaryValue, randomIndex;
    // While there remain elements to shuffle...
    while (0 !== currentIndex) {
        // Pick a remaining element...
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;
        // And swap it with the current element.
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }
    return array;
}

$(document).ready(inicioRedi04);
//variables globales

var arrPreguntas = [{
    num: 1,
    pregunta: 'Sistema de soporte global que permite realizar solicitudes de soporte IT llevando la trazabilidad de los casos:',
    respuestas: [{
        opcion: 'Global service desk',
        img: 'img/gsd.png',
        correcta: true
    }, {
        opcion: 'Contact center',
        img: 'img/contact.png',
        correcta: false
    }],
    retroalimentacion: ''
}, {
    num: 2,
    pregunta: 'Respaldo que se hace de archivos físicos o virtuales en su lugar secundario como una nube y/o un servidor para su conservación y posterior uso en caso de necesidad:',
    respuestas: [{
        opcion: 'SERVIDOR',
        img: 'img/servidor.png',
        correcta: false
    }, {
        opcion: 'BACKUP',
        img: 'img/backup.png',
        correcta: true
    }],
    retroalimentacion: ''
}, {
    num: 3,
    pregunta: 'Para mantener la confidencialidad en el acceso remoto, se describen a continuación las políticas de uso de la aplicación:',
    respuestas: [{
        opcion: 'Acceso VPN, autenticación MFA y activación del portal MFA',
        img: 'img/vpn.png',
        correcta: true
    }, {
        opcion: 'solo activación de portal MFA',
        img: 'img/mf.png',
        correcta: false
    }],
    retroalimentacion: ''
}, {
    num: 4,
    pregunta: 'Esta política busca asegurar la integridad del equipo y de la información que pertenece a la Compañía así como la confidencialidad de la misma:',
    respuestas: [{
        opcion: 'Política de CCTV',
        img: 'img/cctv.png',
        correcta: false
    }, {
        opcion: 'Política de equipo de cómputo',
        img: 'img/computo.png',
        correcta: true
    }],
    retroalimentacion: ''
}, {
    num: 5,
    pregunta: 'El área de logística y soporte al cliente tiene bajo su principal responsabilidad:',
    respuestas: [{
        opcion: 'Recursos suficientes para continuar con la operación del negocio y generar utilidades',
        img: 'img/util.png',
        correcta: false
    }, {
        opcion: 'La materialización de los compromisos comerciales relacionados con la entrega de productos a los clientes',
        img: 'img/entrega.png',
        correcta: true
    }],
    retroalimentacion: ''
}, {
    num: 6,
    pregunta: 'Hace parte de una de las actividades del área de logística y soporte al cliente:',
    respuestas: [{
        opcion: 'Administración del inventario',
        img: 'img/inventario2.png',
        correcta: true
    }, {
        opcion: 'Administración del dinero',
        img: 'img/util.png',
        correcta: false
    }],
    retroalimentacion: ''
}, {
    num: 7,
    pregunta: ' Incluir a los proveedores críticos en la matriz y asegurarse de que quien los contrate suministre la documentación requerida hace parte de la actividad:',
    respuestas: [{
        opcion: 'Procesamiento de pedidos de venta',
        img: 'img/orden.png',
        correcta: false
    }, {
        opcion: 'Compras locales',
        img: 'img/local.png',
        correcta: true
    }],
    retroalimentacion: ''
}, {
    num: 8,
    pregunta: 'Código de la política Gestión de Comercio Exterior y Logística:',
    respuestas: [{
        opcion: 'NI026',
        img: 'img/NI026.png',
        correcta: true
    }, {
        opcion: 'FI026',
        img: 'img/FI026.png',
        correcta: false
    }],
    retroalimentacion: ''
}];

var arrPreguntasInicial = shuffle(arrPreguntas);
var indexPregunta = 0;
var preguntasTotales = arrPreguntasInicial.length;
var idTextoPregunta = "#texto-pregunta";
var imgDerecha = ".derecha .respuestas__imagen";
var imgIzquierda = ".izquierda .respuestas__imagen";
var divDerecho = ".respuestas__derecha";
var divIzquierdo = ".respuestas__izquierda";
var contador1 = ".pregunta__contador1";
var contador2 = ".pregunta__contador2"
var textoModalError = "#textoModalError";
var textoModalExito = "#textoModalExito";
var animacionEntradaPregunta = "entradaElementos";
var contenedorPregunta = ".pregunta";
var pregunta = ".preguntas";
var idModal = ".modalCalificacion";
var puntaje = 0;
var incremento;

function inicioRedi04() {
    mostrarPregunta();
    incremento = 100 / arrPreguntasInicial.length;
}

/*function reinitR4() {
    indexPregunta = 0;
    puntaje = 0;
    arrPreguntasInicial = shuffle(arrPreguntas);
    mostrarPregunta();
}*/

function mostarModalCalificacion() {
    puntaje = puntaje.toFixed(0);
    if (parseInt(puntaje) == 100) {
        exito = true;
        mensaje = "Felicitaciones!";
    } else {
        mensaje = "Inténtalo nuevamente.";
        exito = false;
    }
    mostrarCalificacion(idModal, puntaje + '%',
        exito, reInit);
}

function verificarPregunta(event) {
    if (indexPregunta < arrPreguntasInicial.length) {
        if ($(this).hasClass('respuestas__izquierda')) {
            if ($(divIzquierdo).attr('data-correcto') == 'true') {
                puntaje = puntaje + incremento;
                $(pregunta).addClass('correcto');
                indexPregunta += 1;
                if (indexPregunta == arrPreguntasInicial.length) {
                    setTimeout(function () {
                        mostarModalCalificacion();
                        return 0;
                    }, 1300);
                }
                setTimeout(function () {
                    $(pregunta).removeClass('correcto');
                    mostrarPregunta();
                }, 1300);
            } 
            else {
                $(pregunta).addClass('incorrecto');
                indexPregunta += 1;
                if (indexPregunta == arrPreguntasInicial.length) {
                    setTimeout(function () {
                        mostarModalCalificacion();
                        return 0;
                    }, 1300);
                }
                setTimeout(function () {
                    $(pregunta).removeClass('incorrecto');
                    mostrarPregunta();
                }, 1300);
            }
        } 
        else {
            if ($(divDerecho).attr('data-correcto') == 'true') {
                puntaje = puntaje + incremento;
                $(pregunta).addClass('correcto');
                indexPregunta += 1;
                if (indexPregunta == arrPreguntasInicial.length) {
                    setTimeout(function () {
                        mostarModalCalificacion();
                        return 0;
                    }, 1300);
                }
                setTimeout(function () {
                    $(pregunta).removeClass('correcto');
                    mostrarPregunta();
                }, 1300);
            } 
            else {
                $(pregunta).addClass('incorrecto');
                indexPregunta += 1;
                if (indexPregunta == arrPreguntasInicial.length) {
                    setTimeout(function () {
                        mostarModalCalificacion();
                        return 0;
                    }, 1300);
                }
                setTimeout(function () {
                    $(pregunta).removeClass('incorrecto');
                    mostrarPregunta();
                }, 1300);
            }      
        }
    }

}

function mostrarPregunta() {
    var msjContador1;
    if (indexPregunta + 1 < preguntasTotales) {
        msjContador1 = indexPregunta + 1;
    } else {
        msjContador1 = preguntasTotales;
    }
    var msjContador2 = preguntasTotales;
    $(contador1).text(msjContador1);
    $(contador2).text(msjContador2);
    $(contenedorPregunta).addClass(animacionEntradaPregunta);
    $(divIzquierdo).addClass(animacionEntradaPregunta);
    $(divDerecho).addClass(animacionEntradaPregunta);
    var textoPregunta = arrPreguntasInicial[indexPregunta].pregunta;
    $(idTextoPregunta).html(textoPregunta);
    var respuestas = shuffle(arrPreguntasInicial[indexPregunta].respuestas);
    respuestas.forEach(function (respuesta, index) {
        switch (index) {
            case 0:
                $(imgDerecha).attr('src', respuesta.img);
                $(divDerecho).attr('data-correcto', respuesta.correcta);
                $('.respuestas__textoDerecha').text(respuesta.opcion);
                break;
            case 1:
                $(imgIzquierda).attr('src', respuesta.img);
                $(divIzquierdo).attr('data-correcto', respuesta.correcta);
                $('.respuestas__textoIzquierda').text(respuesta.opcion);
                break;
        }
    });
    $(divDerecho).off('click');
    $(divDerecho).on('click', verificarPregunta);
    $(divIzquierdo).off('click');
    $(divIzquierdo).on('click', verificarPregunta);
    setTimeout(() => {
        $(divIzquierdo).removeClass(animacionEntradaPregunta);
        $(divDerecho).removeClass(animacionEntradaPregunta);
        $(contenedorPregunta).removeClass(animacionEntradaPregunta);
    }, 750);
}